#include <bits/stdc++.h>

using namespace std;

using ll = long long;
int EPS = 1000000007;
vector<vector<int>> g;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<int> a(k);
    vector<int> h(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i] >> h[i];
    }
    unordered_set<int> ans;
    for (int j = 0; j < k; j++) {
        priority_queue<pair<int, int>> pq;
        pq.push({0, a[j] - 1});
        vector<int> dist(n);
        vector<bool> vis(n);
        dist[a[j] - 1] = 0;
        vis[a[j] - 1] = true;
        ans.insert(a[j]);
        while (!pq.empty()) {
            auto [x, y] = pq.top();
            pq.pop();
            for (int i = 0; i < g[y].size(); i++) {
                int v = g[y][i];
                if (!vis[v] || dist[v] > dist[y] + 1) {
                    dist[v] = dist[y] + 1;
                    if (dist[v] <= h[j]) {
                        ans.insert(v + 1);
                    }
                    vis[v] = true;
                    pq.push({dist[v], v});
                }
            }
        }
    }
    cout << ans.size() << '\n';
    vector<int> v(ans.size());
    for (auto x : ans) {
        v.push_back(x);
    }
    sort(v.begin(), v.end());
    for (auto x : v) {
        cout << x << ' ';
    }
    return 0;
}
