#include <bits/stdc++.h>

using namespace std;

using ll = long long;
int EPS = 1000000007;
vector<vector<int>> g;
unordered_set<int> ans;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<int> a(k);
    vector<int> h(k);
    int mx = -1;
    for (int i = 0; i < k; i++) {
        cin >> a[i] >> h[i];
        mx = max(mx, h[i]);
    }
    vector<pair<int, int>> dist(n, {EPS, -1});
    vector<bool> vis(n);
    set<pair<int, int>> pq;
    for (int j = 0; j < k; j++) {
        pq.insert({0, a[j] - 1});
        dist[a[j] - 1].first = 0;
        dist[a[j] - 1].second = h[j];
        vis[a[j] - 1] = true;
        ans.insert(a[j]);
    }
    while (!pq.empty()) {
        auto [x, y] = *pq.begin();
        pq.erase(pq.begin());
        for (int i = 0; i < g[y].size(); i++) {
            int v = g[y][i];
            if (!vis[v] || dist[v].first >= dist[y].first + 1) {
                dist[v].first = dist[y].first + 1;
                dist[v].second = max(dist[y].second, dist[v].second);
                if (dist[v].first <= dist[v].second) {
                    ans.insert(v + 1);
                }
                vis[v] = true;
                pq.insert({dist[v].first, v});
            }
        }
    }
    cout << ans.size() << '\n';
    vector<int> v;
    for (auto x : ans) {
        v.push_back(x);
    }
    sort(v.begin(), v.end());
    for (auto x : v) {
        cout << x << ' ';
    }
    return 0;
}
